
use strict;  # make Test::Perl::Critic happy

package Mail::SpamAssassin::Bayes::CombineNaiveBayes; 1;

package Mail::SpamAssassin::Bayes::Combine;

use strict;
use warnings;
use re 'taint';


our $FW_X_CONSTANT = 0.600;

our $FW_S_CONSTANT = 0.160;

our $FW_S_DOT_X = ($FW_X_CONSTANT * $FW_S_CONSTANT);

our $MIN_PROB_STRENGTH = 0.430;


sub combine {
  my ($ns, $nn, $sortedref) = @_;

  my $wc = scalar @$sortedref;
  return unless $wc;

  my $P = 1;
  my $Q = 1;

  foreach my $pw (@$sortedref) {
    $P *= (1-$pw);
    $Q *= $pw;
  }
  $P = 1 - ($P ** (1 / $wc));
  $Q = 1 - ($Q ** (1 / $wc));
  return (1 + ($P - $Q) / ($P + $Q)) / 2.0;
}

1;
