
package Mail::SpamAssassin::BayesStore::SDBM;

use strict;
use warnings;
use re 'taint';
use Fcntl;

use Mail::SpamAssassin::BayesStore::DBM;
use Mail::SpamAssassin::Logger;

our @ISA = qw( Mail::SpamAssassin::BayesStore::DBM );

sub HAS_DBM_MODULE {
  my ($self) = @_;
  if (exists($self->{has_dbm_module})) {
    return $self->{has_dbm_module};
  }
  $self->{has_dbm_module} = eval { require SDBM_File; };
}

sub DBM_MODULE {
  return "SDBM_File";
}

sub DB_EXTENSIONS {
  return ('.pag', '.dir');
}

sub _unlink_file {
  my ($self, $filename) = @_;

  for my $ext ($self->DB_EXTENSIONS) {
    unlink $filename . $ext;
  }
}

sub _rename_file {
  my ($self, $sourcefilename, $targetfilename) = @_;

  for my $ext ($self->DB_EXTENSIONS) {
    return 0 unless (rename($sourcefilename . $ext, $targetfilename . $ext));
  }
  return 1;
}

sub perform_upgrade {

  return 1;
}


1;
