
package Mail::SpamAssassin::Locker;

use strict;
use warnings;
use re 'taint';
use Fcntl;
use Time::HiRes ();

use Mail::SpamAssassin;

our @ISA = qw();


sub new {
  my $class = shift;
  $class = ref($class) || $class;
  my $self = { };
  bless ($self, $class);
  $self;
}


sub safe_lock {
  my ($self, $path, $max_retries, $mode) = @_;
  # max_retries is optional, should default to about 30
  # mode is UNIX-style and optional, should default to 0700,
  # callers must specify --x bits
  die "locker: safe_lock not implemented by Locker subclass";
}


sub safe_unlock {
  my ($self, $path) = @_;
  die "locker: safe_unlock not implemented by Locker subclass";
}


sub refresh_lock {
  my ($self, $path) = @_;
  die "locker: refresh_lock not implemented by Locker subclass";
}


sub jittery_one_second_sleep {
  my ($self) = @_;
  Time::HiRes::sleep(rand(1.0) + 0.5);
}

sub jittery_half_second_sleep {
  my ($self) = @_;
  Time::HiRes::sleep(rand(0.5) + 0.25);
}


1;
