

use strict;  # make Test::Perl::Critic happy
package Mail::SpamAssassin::MailingList; 1;

package Mail::SpamAssassin::PerMsgStatus;

use strict;
use warnings;
use re 'taint';

sub detect_mailing_list {
    my ($self) = @_;
    return 1 if $self->detect_ml_ezmlm();
    return 1 if $self->detect_ml_mailman();
    return 1 if $self->detect_ml_sympa();
    return 0;
}

sub detect_ml_ezmlm {
    my ($self) = @_;
    return 0 unless $self->get('mailing-list') =~ /ezmlm$/;
    return 0 unless $self->get('precedence') eq "bulk\n";
    return 0 unless $self->get('list-post') =~ /^<mailto:/i;
    return 0 unless $self->get('list-help') =~ /^<mailto:/i;
    return 0 unless $self->get('list-unsubscribe') =~ /<mailto:[a-zA-Z\.-]+-unsubscribe\@/i;
    return 0 unless $self->get('list-subscribe') =~ /<mailto:[a-zA-Z\.-]+-subscribe\@/i;
    return 1; # assume ezmlm then.
}

sub detect_ml_mailman {
    my ($self) = @_;
    return 0 unless $self->get('x-mailman-version') =~ /^\d/;
    return 0 unless $self->get('precedence') =~ /^(?:bulk|list)$/;

    if ($self->get('x-list-administrivia') =~ /yes/ ||
        $self->get('subject') =~ /mailing list memberships reminder$/)
    {
        return 0 unless defined $self->get('errors-to',undef);
        return 0 unless defined $self->get('x-beenthere',undef);
        return 0 unless $self->get('x-no-archive') =~ /yes/;
        return 1;
    }

    return 0 unless defined $self->get('list-id',undef);
    return 0 unless $self->get('list-help') =~ /^<mailto:/i;
    return 0 unless $self->get('list-post') =~ /^<mailto:/i;
    return 0 unless $self->get('list-subscribe') =~ /<mailto:.*=subscribe>/i;
    return 0 unless $self->get('list-unsubscribe') =~ /<mailto:.*=unsubscribe>/i;
    return 1; # assume this is a valid mailman list
}


sub detect_ml_sympa {
    my ($self) = @_;
    return 1 if $self->get('X-Mailer') =~ /^Sympa \d\.\d\.\d/;
    return 1 if defined ($self->get('X-Sympa-To',undef));
    return 0;
}

sub detect_ml_lyris {
}



1;
