

package Mail::SpamAssassin::PerMsgLearner;

use strict;
use warnings;
use re 'taint';

use Mail::SpamAssassin;
use Mail::SpamAssassin::PerMsgStatus;
use Mail::SpamAssassin::Bayes;
use Mail::SpamAssassin::Logger;

our @ISA = qw();


sub new {
  my $class = shift;
  $class = ref($class) || $class;
  my ($main, $msg) = @_;

  my $self = {
    'main'              => $main,
    'msg'               => $msg,
    'learned'		=> 0,
    'master_deadline'   => $msg->{master_deadline},  # dflt inherited from msg
  };

  $self->{conf} = $self->{main}->{conf};

  $self->{bayes_scanner} = $self->{main}->{bayes_scanner};

  bless ($self, $class);
  $self;
}



sub learn_spam {
  my ($self, $id) = @_;

  # bug 4096
  # if ($self->{main}->{learn_with_welcomelist}) {
  # $self->{main}->add_all_addresses_to_blocklist ($self->{msg});
  # }

  # use the real message-id here instead of mass-check's idea of an "id",
  # as we may deliver the msg into another mbox format but later need
  # to forget it's training.
  $self->{learned} = $self->{bayes_scanner}->learn (1, $self->{msg}, $id);
}



sub learn_ham {
  my ($self, $id) = @_;

  # bug 4096
  # if ($self->{main}->{learn_with_welcomelist}) {
  # $self->{main}->add_all_addresses_to_welcomelist ($self->{msg});
  # }

  $self->{learned} = $self->{bayes_scanner}->learn (0, $self->{msg}, $id);
}



sub forget {
  my ($self, $id) = @_;

  # bug 4096
  # if ($self->{main}->{learn_with_welcomelist}) {
  # $self->{main}->remove_all_addresses_from_welcomelist ($self->{msg});
  # }

  $self->{learned} = $self->{bayes_scanner}->forget ($self->{msg}, $id);
}



sub did_learn {
  my ($self) = @_;
  return ($self->{learned});
}



sub finish {
  my $self = shift;
  %{$self} = ();
}


1;
__END__

