

package Mail::SpamAssassin::Util::ScopedTimer;

use strict;
use warnings;
use re 'taint';

our @ISA = qw();

sub new {
  my $class = shift;
  my $self = {
    main => shift,
    timer => shift,
  };
  $self->{main}->timer_start($self->{timer});
  return bless ($self, $class);
}

sub DESTROY {
  my $self = shift;
  # best practices: prevent potential calls to eval and to system routines
  # in code of a DESTROY method from clobbering global variables $@ and $! 
  local($@,$!);  # keep outer error handling unaffected by DESTROY
  $self->{main} && $self->{timer} && $self->{main}->timer_end($self->{timer});
}

1;
